/* StarPU --- Runtime system for heterogeneous multicore architectures.
 *
 * Copyright (C) 2012  Inria
 *
 * StarPU is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or (at
 * your option) any later version.
 *
 * StarPU is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See the GNU Lesser General Public License in COPYING.LGPL for more details.
 */

#ifndef __DRIVER_MIC_SINK_H__
#define __DRIVER_MIC_SINK_H__

#include <common/config.h>

#ifdef STARPU_USE_MIC

#include <scif.h>

#include <drivers/mp_common/mp_common.h>
#include <drivers/mp_common/sink_common.h>


#define STARPU_MIC_SINK_REPORT_ERROR(status) \
	_starpu_mic_sink_report_error(__starpu_func__, __FILE__, __LINE__, status)


void _starpu_mic_sink_report_error(const char *func, const char *file, const int line, const int status);

void _starpu_mic_sink_init(struct _starpu_mp_node *node);

void _starpu_mic_sink_deinit(struct _starpu_mp_node *node);

unsigned int _starpu_mic_sink_get_nb_core(void);

void _starpu_mic_sink_allocate(const struct _starpu_mp_node *mp_node, void *arg, int arg_size);
void _starpu_mic_sink_free(const struct _starpu_mp_node *mp_node STARPU_ATTRIBUTE_UNUSED, void *arg, int arg_size);

#endif /* STARPU_USE_MIC */


#endif /* __DRIVER_MIC_SINK_H__ */
