/* StarPU --- Runtime system for heterogeneous multicore architectures.
 *
 * Copyright (C) 2013  Université de Bordeaux 1
 *
 * StarPU is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or (at
 * your option) any later version.
 *
 * StarPU is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See the GNU Lesser General Public License in COPYING.LGPL for more details.
 */

#include <starpu.h>

static __global__ void cuda_increment(unsigned *var)
{
	(*var)++;
}

extern "C" void cuda_host_increment(void *descr[], void *_args)
{
	(void)_args;
	unsigned *var = (unsigned *)STARPU_VARIABLE_GET_PTR(descr[0]);
	cudaError_t cures;

	cuda_increment<<<1,1, 0, starpu_cuda_get_local_stream()>>>(var);
	cures = cudaStreamSynchronize(starpu_cuda_get_local_stream());
	if (cures != cudaSuccess)
		STARPU_CUDA_REPORT_ERROR(cures);
}
